#include <LiquidCrystal.h>
#include<AccelStepper.h>
#define HALFSTEP 8
// Определение пинов для управления двигателем
#define motorPin1  A1 // IN1 на 1-м драйвере ULN2003
#define motorPin2  A2 // IN2 на 1-м драйвере ULN2003
#define motorPin3  A3// IN3 на 1-м драйвере ULN2003
#define motorPin4  A4 // IN4 на 1-м драйвере ULN2003
// для использования AccelStepper с 28BYJ-48
AccelStepper stepper(HALFSTEP, motorPin1, motorPin3, motorPin2, motorPin4);
// Инициализируемся в последовательности (метод управления, IN1, IN3, IN2, IN4)
// stepper1 - это произвольно придуманное нами имя для двигателя
#include <EEPROM.h>
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

int sensorDigitalPin = 12; // назначение пина для датчика

byte KEY; // значение нажатой кнопки
int button = 0; // флаг нажатия кнопки
byte button_Long = 0;// флаг долгого нажатия кнопки

int Schet_kapli = 0; //заданное значение количества капель
int Datchik_kapli = 0; // реальное количество капель
int koeficient = 0;
int schetchik = 0; // кол-во капель
int motor = 0;
int motor_Display = 0;
unsigned long myScaleMillis = 0;
unsigned long previousMillis = 0;


byte Key() { // проверяем кнопки шилда
  if (analogRead(0) < 50) return 3; // вправо
  else if (analogRead(0) < 180) return 2; //вверх
  else if (analogRead(0) < 350) return 4;// вниз
  else if (analogRead(0) < 550) return 1; // влево
  else if (analogRead(0) < 800) return 5; //sekect
  else if (analogRead(0) < 1025) return 0;
}

void setup() {
  pinMode (sensorDigitalPin, INPUT); // активируем датчик счетчика капель

  stepper.setMaxSpeed(20.0);// Скорость вращения вала двигателя.
  stepper.setAcceleration(800.0);// Темп разгона-торможения двигателя.
  stepper.setSpeed(800);//

  Serial.begin(9600);

  lcd.begin(16, 2);  // включаем экран
  lcd.clear();       // очищаем экран

}

void loop() {

  Key();//убираем дребезг кнопок
  if (Key() != 0) {
    if (millis() - previousMillis >= 300) {
      previousMillis = millis();
      KEY = Key();
      button = button + 1;
      if (button > 11) button_Long = 1;// фключаем флаг долгого нажатия
    }  else KEY = 0;
  }
  if (Key() == 0) {
    KEY = 0;
    button = 0;
    button_Long = 0;
  }
  EEPROM.get(0, Schet_kapli);
  if (isnan(Schet_kapli)) {
    Schet_kapli = 0;
    EEPROM.put(0, Schet_kapli);
  }

  if (Serial.available() > 0) {// определяем значение реальной мощности
    Schet_kapli = Serial.read();
    EEPROM.put(0, Schet_kapli);
  }

  Datchik_kapli = digitalRead (sensorDigitalPin) ;// чтение значения с датчика
  if (Datchik_kapli == HIGH && koeficient == 0) //
  {
    schetchik = schetchik + 1;
    koeficient = 1;
  }
  if (Datchik_kapli == LOW) //
  {
    koeficient = 0;
  }

  if (millis() - myScaleMillis >= 10000) {
    myScaleMillis = millis();
    if (schetchik < Schet_kapli - 10)motor = 5;
    if (schetchik <= Schet_kapli - 2 && schetchik >= Schet_kapli - 10)motor = 4;
    if (schetchik > Schet_kapli - 2 && schetchik < Schet_kapli + 2)motor = 0;
    if (schetchik >= Schet_kapli + 2 && schetchik <= Schet_kapli + 6 )motor = 1;
    if (schetchik > Schet_kapli + 6 && schetchik <= Schet_kapli + 10 )motor = 2;
    if (schetchik > Schet_kapli + 10) motor = 3;
    schetchik = 0;
    motor_Display = motor;
  }


  lcd.setCursor(0, 0);
  lcd.print (schetchik);  // показываем температуру с датчика царги
  lcd.print ("   ");
  lcd.setCursor(6, 0);
  lcd.print (motor_Display);
  lcd.print ("   ");

  lcd.setCursor(0, 1);
  lcd.print (Schet_kapli);  // показываем температуру с датчика царги
  lcd.print ("  ");

  long time = millis() / 1000;
  lcd.setCursor(6, 1);
  if ((time / 60 / 60) % 60 < 10) {
    lcd.print ("0");
  }
  lcd.print (time / 60 / 60); // час
  lcd.setCursor(8, 1);
  if (time % 2 == 1)  lcd.print (":");
  else   lcd.print (" ");
  lcd.setCursor(9, 1);
  if (time / 60 % 60 < 10) {
    lcd.print ("0");
  }
  lcd.print ((time / 60) % 60);

  if (KEY == 4) { // если нажата кнопка
    if (button_Long == 0) Schet_kapli = Schet_kapli - 1; // изменяем значение
    if (button_Long == 1) Schet_kapli = Schet_kapli - 10; // изменяем значение
    if (Schet_kapli < 0) Schet_kapli = 0;
    if (Schet_kapli > 50) Schet_kapli = 50;
    EEPROM.put(0, Schet_kapli); // сохраняем в еепром
  }

  if (KEY == 2) {
    if (button_Long == 0) Schet_kapli = Schet_kapli + 1; // изменяем значение
    if (button_Long == 1) Schet_kapli = Schet_kapli + 10;
    if (Schet_kapli > 50) Schet_kapli = 50;
    if (Schet_kapli < 0) Schet_kapli = 0;
    EEPROM.put(0, Schet_kapli);
  }
  if (Key() == 1) {
 stepper.moveTo(50);
      stepper.run();
  }
    if (Key() == 3) {
 stepper.moveTo(-50);
      stepper.run();
  }
  stepper.stop();
   stepper.disableOutputs();
  if (Key() != 1 && Key() != 3) {
    // управление мотором

    if (motor == 1) {
      stepper.moveTo(20);
      stepper.run();
      if (stepper.distanceToGo() == 0) {
        stepper.setCurrentPosition(0);//_________________________________________________________________
        motor = 30;
      }
    }

    if (motor == 2) {
      stepper.moveTo(50);
      stepper.run();
      if (stepper.distanceToGo() == 0) {
        stepper.setCurrentPosition(0);//_________________________________________________________________
        motor = 30;
      }
    }

    if (motor == 3) {
      stepper.moveTo(200);
      stepper.run();
      if (stepper.distanceToGo() == 0) {
        stepper.setCurrentPosition(0);//_________________________________________________________________
        motor = 30;
      }
    }

    if (motor == 4) {
      stepper.moveTo(-30);
      stepper.run();
      if (stepper.distanceToGo() == 0) {
        stepper.setCurrentPosition(0);//_________________________________________________________________
        motor = 30;
      }
    }

    if (motor == 5) {
      stepper.moveTo(-100);
      stepper.run();
      if (stepper.distanceToGo() == 0) {
        stepper.setCurrentPosition(0);//_________________________________________________________________
        motor = 30;
      }
    }

//    if (motor == 30) {
//      stepper.disableOutputs();
//      stepper.stop();
//
//      motor = 100;
//    }

  }
}

